
;Programmet er utviklet av Sondre Danielsen. 

	LIST    P=16f84
	include <p16F84.inc>

	__CONFIG       _CP_OFF & _PWRTE_ON & _WDT_OFF & _XT_OSC

teller1	equ	0c		
teller2 equ	0d
teller3 equ	0e
teller4	equ	0f
sp	equ	10		;register for split point frekvens	




	bsf	3,5
	movlw	B'11111000'	;setter portb til innganger og utganger
	movwf	trisb
	movlw	B'00000000'	;setter borta til utgang
	movwf	trisa
	bcf	3,5

	clrf	sp
	clrf 	porta
	clrf	portb
	bsf	portb,2		;setter csn til 1


;--------------------------------------------------

Start	

;---- sjekker hvilken stilling split point velgeren str i ----	

	btfss	portb,3		;Split point frekvens: 1966 Hz
	goto	s1
	bcf	sp,0
	bcf	sp,1

s1	btfss	portb,4		;Split point frekvens: 1482 Hz
	goto	s2
	bsf	sp,0
	bcf	sp,1

s2	btfss	portb,5		;Split point frekvens: 1276 Hz
	goto	s3
	bcf	sp,0
	bsf	sp,1

s3	btfss	portb,6		;Split point frekvens: 1027 Hz
	goto	s4
	bsf	sp,0
	bsf	sp,1

s4
	call	sekund		;Venter 1 sekund


;---- Sender data til scrambler krets ----

	bcf	portb,2		;setter csn til 0
	nop
	nop
	bcf	portb,0		;Bit 10
	nop
	bsf	portb,1		;setter clock til 1
	nop
	bcf	portb,1		;setter clock til 0

	nop
	btfsc	portb,7		;sjekker om scrambling skal vre aktiv
	bsf	portb,0
	btfss	portb,7
	bcf	portb,0		;bit9
	nop
	bsf	portb,1		;setter clock til 1
	nop
	bcf	portb,1		;setter clock til 0

	nop
	bsf	portb,0		;Bit 8
	nop
	bsf	portb,1		;setter clock til 1
	nop
	bcf	portb,1		;setter clock til 0

	nop
	bsf	portb,0		;Bit 7
	nop
	bsf	portb,1		;setter clock til 1
	nop
	bcf	portb,1		;setter clock til 0

	nop
	bsf	portb,0		;Bit 6
	nop
	bsf	portb,1		;setter clock til 1
	nop
	bcf	portb,1		;setter clock til 0

	nop
	bsf	portb,0		;Bit 5
	nop
	bsf	portb,1		;setter clock til 1
	nop
	bcf	portb,1		;setter clock til 0

	nop
	bsf	portb,0		;Bit 4
	nop
	bsf	portb,1		;setter clock til 1
	nop
	bcf	portb,1		;setter clock til 0

	nop
	bsf	portb,0		;Bit 3
	nop
	bsf	portb,1		;setter clock til 1
	nop
	bcf	portb,1		;setter clock til 0

	nop
	bsf	portb,0		;Bit 2
	nop
	bsf	portb,1		;setter clock til 1
	nop
	bcf	portb,1		;setter clock til 0

	nop
	btfsc	sp,1		;sjekker split point frekvens
	bsf	portb,0
	btfsc	sp,1
	bcf	portb,0		;bit1
	nop
	bsf	portb,1		;setter clock til 1
	nop
	bcf	portb,1		;setter clock til 0

	nop
	btfsc	sp,0		;sjekker split point frekvens
	bsf	portb,0
	btfsc	sp,0
	bcf	portb,0		;bit0
	nop
	bsf	portb,1		;setter clock til 1
	nop
	bcf	portb,1		;setter clock til 0

	nop
	nop
	bsf	portb,2		;setter csn til 1


	btfsc	portb,7		;sjekker om scrambling skal vre aktiv
	bsf	porta,0		;Rd lys diode
	btfss	portb,7
	bcf	porta,0	

	btfsc	portb,7		;sjekker om scrambling skal vre aktiv
	bcf	porta,1		;Grnn lysdiode
	btfss	portb,7
	bsf	porta,1	

	goto	start


;---- venterutine 1 sekund ------

sekund	movlw	.4			;4 ved 4 Mhz krystall
	movwf	teller4
loop4	movlw	.248			;B	248		
	movwf	teller2
loop2	movlw	.251			;A	251
	movwf	teller1
loop1	nop
	decfsz	teller1
	goto	loop1
	decfsz	teller2
	goto	loop2
	decfsz	teller4
	goto	loop4			
	return


	END

